package PresentationLayer.Forms;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.text.html.HTMLEditorKit;

/**
 * obsahuje popis prvků obvodu
 * @author Jakub Hrncir (2010)
 */
public class CircuitPanel extends JPanel {

    private MainForm mf;
    private JScrollPane scrollPane;
    private JEditorPane text;

    public CircuitPanel(MainForm mf) {
        super();
        setPreferredSize(new Dimension(250, 120));
        setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED),"Vlastnosti prvku obvodu", TitledBorder.LEFT,TitledBorder.DEFAULT_POSITION,MainForm.FONT_B));
        this.mf = mf;
        init();

    }

    private void init() {
        setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;
        c.weighty = 1;
        text = new JEditorPane();
        text.setEditable(false);
        scrollPane = new JScrollPane(text);
        scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        add(scrollPane, c);
        text.setEditable(false);
        text.setEditorKit(new HTMLEditorKit());
    }

    public void setText(String s){
        text.setText(s);
    }
}
