package PresentationLayer.Forms;

import ApplicationLayer.ApplicationLayer;
import java.awt.Desktop;
import java.awt.Dimension;
import java.io.IOException;
import java.net.URISyntaxException;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLEditorKit;

/**
 * obsah pro tlačítko O Programu
 * @author Jakub Hrncir (2010)
 */
public class InfoPanel extends JPanel {

    private JEditorPane ep;

    public InfoPanel() {
        super();
        setPreferredSize(new Dimension(400, 110));
        init();
    }

    private void init() {
        ep = new JEditorPane();
        ep.setEditable(false);
        ep.setEditorKit(new HTMLEditorKit());
        ep.setText(ApplicationLayer.loadFileToString("html/info.html"));
        add(ep);
        ep.addHyperlinkListener(new HyperlinkListener() {

            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                    Desktop d = Desktop.getDesktop();
                    try {
                        d.browse(e.getURL().toURI());
                    } catch (IOException ex) {
                    } catch (URISyntaxException ex) {
                    }
                }
            }
        });
    }
}
