package PresentationLayer.Grid;

import java.util.ArrayList;

/**
 * jeden řádek mřížky
 * @author Jakub Hrncir (2010)
 */
public class CircuitGridLine {

    public ArrayList<GridField> fields;

    public CircuitGridLine(int col) {
        fields = new ArrayList<GridField>();
        for (int i = 0; i < col; i++) {
            fields.add(new GFEmpty());
        }
    }

    /**
     * @return zda je řádek prázdný
     */
    public boolean isEmpty() {
        for (int i = 0; i < fields.size(); i++) {
            if (!fields.get(i).getClass().equals(GFEmpty.class)) {
                return false;
            }
        }
        return true;
    }

    /**
     * nahradí GFEmpty místo GFWires (a GFNodes) bez drátů (north,east,south a west == false)
     */
    public void clearEmptyWires() {
        for (int i = 0; i < fields.size(); i++) {
            if (fields.get(i).isCleared()) {
                fields.set(i, new GFEmpty());
            }
        }
    }

    public int getColCount(){
        return fields.size();
    }
}
