package PresentationLayer.Grid;

import java.awt.Color;
import java.awt.Graphics;

/**
 * prázdné políčko
 * @author Jakub Hrncir (2010)
 */
public class GFEmpty extends GridField {
    
    /**
     * nastaví barvu zvýraznění
     * @param green musí být mezi 0-1, 0 je nejsvětlejší, 1 nejtmavší zelená
     */
    @Override
    public Color setHighlightColor(double green) {
        color_highlight = new Color((int) ((1 - green) * COLOR_CONST), 255, (int) ((1 - green) * COLOR_CONST));
        return new Color((int) ((1 - green) * COLOR_CONST), 255, (int) ((1 - green) * COLOR_CONST));
    }

    @Override
    public void paint(Graphics g, int x1, int y1, int GC, boolean selected, boolean paintMarks) {
        g.setColor((selected) ? COLOR_SELECT : COLOR_NOSELECT);
        if (dragSelected) {
            g.setColor(COLOR_DRAGSELECT);
        }
        if (highlighted) {
            g.setColor(color_highlight);
        }
        g.fillRect(x1, y1, GC, GC);
        g.setColor(COLOR_BORDER);
        g.drawRect(x1, y1, GC, GC);

    }

    @Override
    public boolean isCleared() {
        return false;
    }

    @Override
    public void setHighlightColor() {
        color_highlight = COLOR_HIGHLIGHT;
    }
}
