package PresentationLayer.Grid;

import ApplicationLayer.Direction;
import java.awt.Font;
import java.awt.Graphics;

/**
 * políčko uzlu
 * @author Jakub Hrncir (2010)
 */
public class GFNode extends GFWire {

    private boolean knowCurrents;
    private int currentNorth;//1:směr proudu je k uzlu/-1: od uzlu/0 nevede proud
    private int currentEast;
    private int currentSouth;
    private int currentWest;
    private String mark = "";
    public int[] branches = new int[4];

    public GFNode(GFWire wire) {
        super(wire.north, wire.east, wire.south, wire.west);
        knowCurrents = false;
    }

    @Override
    public void paint(Graphics g, int x1, int y1, int GC, boolean selected, boolean paintMarks) {
        g.setFont(new Font("Arial", Font.PLAIN, GC / 5));
        g.setColor((selected) ? COLOR_SELECT : COLOR_NOSELECT);
        setFillColor(g, selected);
        g.fillRect(x1, y1, GC, GC);
        g.setColor(COLOR_BORDER);
        g.drawRect(x1, y1, GC, GC);
        g.setColor(COLOR_LINE);
        if (isNorth()) {
            g.drawLine(x1 + (GC / 2), y1, x1 + (GC / 2), y1 + (GC / 2));
            if (paintMarks & knowCurrents) {
                if (currentNorth == 1) {
                    g.drawLine(x1 + (2 * GC / 5), y1 + (3 * GC / 10), x1 + (GC / 2), y1 + (2 * GC / 5));
                    g.drawLine(x1 + (3 * GC / 5), y1 + (3 * GC / 10), x1 + (GC / 2), y1 + (2 * GC / 5));
                }
                if (currentNorth == -1) {
                    g.drawLine(x1 + (2 * GC / 5), y1 + GC / 10, x1 + (GC / 2), y1);
                    g.drawLine(x1 + (3 * GC / 5), y1 + GC / 10, x1 + (GC / 2), y1);
                }
            }
            //g.setColor(COLOR_BORDER);
            if (paintMarks & branches[0] != 0) {
                setFillColor(g, selected);
                g.fillRect(x1 + 7 * GC / 20, y1 + 11 * GC / 40 - GC / 6, (int) Math.round(Integer.toString(branches[0]).length() * GC / 9), GC / 6 + 1);
                g.setColor(COLOR_LINE);
                g.drawString(Integer.toString(branches[0]), x1 + 7 * GC / 20, y1 + 11 * GC / 40);
            }
        }
        g.setColor(COLOR_LINE);
        if (isEast()) {
            g.drawLine(x1 + (GC / 2), y1 + (GC / 2), x1 + GC, y1 + (GC / 2));
            if (paintMarks & knowCurrents) {
                if (currentEast == 1) {
                    g.drawLine(x1 + 7 * GC / 10, y1 + (2 * GC / 5), x1 + (3 * GC / 5), y1 + (GC / 2));
                    g.drawLine(x1 + 7 * GC / 10, y1 + (3 * GC / 5), x1 + (3 * GC / 5), y1 + (GC / 2));
                }
                if (currentEast == -1) {
                    g.drawLine(x1 + 9 * GC / 10, y1 + (2 * GC / 5), x1 + GC, y1 + (GC / 2));
                    g.drawLine(x1 + 9 * GC / 10, y1 + (3 * GC / 5), x1 + GC, y1 + (GC / 2));
                }
            }
            if (paintMarks & branches[1] != 0) {
                g.drawString(Integer.toString(branches[1]), x1 + 3 * GC / 4, y1 + 2 * GC / 5);
            }
        }
        g.setColor(COLOR_LINE);
        if (isSouth()) {
            g.drawLine(x1 + (GC / 2), y1 + (GC / 2), x1 + (GC / 2), y1 + GC);
            if (paintMarks & knowCurrents) {
                if (currentSouth == 1) {
                    g.drawLine(x1 + (2 * GC / 5), y1 + 7 * GC / 10, x1 + (GC / 2), y1 + (3 * GC / 5));
                    g.drawLine(x1 + (3 * GC / 5), y1 + 7 * GC / 10, x1 + (GC / 2), y1 + (3 * GC / 5));
                }
                if (currentSouth == -1) {
                    g.drawLine(x1 + (2 * GC / 5), y1 + 9 * GC / 10, x1 + (GC / 2), y1 + GC);
                    g.drawLine(x1 + (3 * GC / 5), y1 + 9 * GC / 10, x1 + (GC / 2), y1 + GC);
                }
            }
            if (paintMarks & branches[2] != 0) {
                setFillColor(g, selected);
                g.fillRect(x1 + 7 * GC / 20, y1 + 7 * GC / 8 - GC / 6, (int) Math.round(Integer.toString(branches[2]).length() * GC / 9), GC / 6 + 1);
                g.setColor(COLOR_LINE);
                g.drawString(Integer.toString(branches[2]), x1 + 7 * GC / 20, y1 + 7 * GC / 8);
            }
        }
        g.setColor(COLOR_LINE);
        if (isWest()) {
            g.drawLine(x1, y1 + (GC / 2), x1 + (GC / 2), y1 + (GC / 2));
            if (paintMarks & knowCurrents) {
                if (currentWest == 1) {
                    g.drawLine(x1 + 3 * GC / 10, y1 + (2 * GC / 5), x1 + (2 * GC / 5), y1 + (GC / 2));
                    g.drawLine(x1 + 3 * GC / 10, y1 + (3 * GC / 5), x1 + (2 * GC / 5), y1 + (GC / 2));
                }
                if (currentWest == -1) {
                    g.drawLine(x1 + GC / 10, y1 + (2 * GC / 5), x1, y1 + (GC / 2));
                    g.drawLine(x1 + GC / 10, y1 + (3 * GC / 5), x1, y1 + (GC / 2));
                }
            }
            if (paintMarks & branches[3] != 0) {
                g.drawString(Integer.toString(branches[3]), x1 + 3 * GC / 20, y1 + 2 * GC / 5);
            }
        }
        g.fillOval((int) (x1 + 0.4 * GC), (int) (y1 + 0.4 * GC), (int) (0.2 * GC), (int) (0.2 * GC));
        g.setColor(COLOR_BORDER);
        if (paintMarks) {
            g.drawString(getMark(), x1 + (17 * GC / 20), y1 + (39 * GC / 40));
        }
    }

    /**
     * @param dir
     * @param current 1/0/-1 → k uzlu/žádný/od uzlu
     */
    public void setCurrent(Direction dir, int current) {
        switch (dir) {
            case NORTH:
                currentNorth = current;
                break;
            case EAST:
                currentEast = current;
                break;
            case SOUTH:
                currentSouth = current;
                break;
            case WEST:
                currentWest = current;
        }
    }

    public void resetCurrents() {
        currentNorth = 0;
        currentEast = 0;
        currentSouth = 0;
        currentWest = 0;

    }

    public int getCurrent(Direction dir) {
        switch (dir) {
            case NORTH:
                return currentNorth;
            case EAST:
                return currentEast;
            case SOUTH:
                return currentSouth;
            case WEST:
                return currentWest;
            default:
                return 0;
        }
    }

    public void invertCurrent(Direction dir) {
        switch (dir) {
            case NORTH:
                currentNorth = -currentNorth;
                break;
            case EAST:
                currentEast = -currentEast;
                break;
            case SOUTH:
                currentSouth = -currentSouth;
                break;
            case WEST:
                currentWest = -currentWest;
        }
    }

    /**
     * @param know if field knows the currents
     */
    public void setKnowCurrents(boolean know) {
        knowCurrents = know;
    }

    /**
     * @param mark the mark to set
     */
    public void setMark(String mark) {
        this.mark = mark;
    }

    /**
     * @return the mark
     */
    public String getMark() {
        return mark;
    }

    public void setBranch(Direction dir, int mark) {
        switch (dir) {
            case NORTH:
                branches[0] = mark;
                break;
            case EAST:
                branches[1] = mark;
                break;
            case SOUTH:
                branches[2] = mark;
                break;
            case WEST:
                branches[3] = mark;
        }
    }

    public char getCharMark() {
        return mark.charAt(0);
    }
}
