
package PresentationLayer.Grid;

import ApplicationLayer.NumOp;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

/**
 * políčko rezistoru
 * @author Jakub Hrncir (2010)
 */
public class GFResistor extends GridField implements Orientable{

    private boolean horizontal;
    private double resistance;

    public GFResistor(GFWire wire, double resistance) {
        horizontal = (wire.isHorizontal()) ? true : false;
        this.resistance = resistance;
    }
    /**
     * nastaví barvu zvýraznění
     * @param green musí být mezi 0-1, 0 je nejsvětlejší, 1 nejtmavší zelená
     */
    @Override
    public Color setHighlightColor(double green) {
        color_highlight = new Color((int) ((1 - green) * COLOR_CONST), 255, (int) ((1 - green) * COLOR_CONST));
        return new Color((int) ((1 - green) * COLOR_CONST), 255, (int) ((1 - green) * COLOR_CONST));
    }
    @Override
    public void setHighlightColor() {
        color_highlight = COLOR_HIGHLIGHT;
    }

    @Override
    public void paint(Graphics g, int x1, int y1, int GC, boolean selected, boolean paintMarks) {
        setFillColor(g, selected);
        g.fillRect(x1, y1, GC, GC);
        g.setColor(COLOR_BORDER);
        g.drawRect(x1, y1, GC, GC);
        g.setColor(COLOR_LINE);
        if (isHorizontal()) {
            g.drawLine(x1, y1 + (GC / 2), x1 + (GC / 4), y1 + (GC / 2));
            g.drawRect(x1 + (GC / 4), y1 + 3 * (GC / 8), GC / 2, GC / 4);
            g.drawLine(x1 + GC - (GC / 4), y1 + (GC / 2), x1 + GC, y1 + (GC / 2));
            g.setFont(new Font("Arial", Font.PLAIN, GC / 5));
            g.drawString(NumOp.writeDouble(resistance), x1 + GC / 8, y1 + GC / 4);
        } else {
            g.drawLine(x1 + (GC / 2), y1, x1 + (GC / 2), y1 + (GC / 4));
            g.drawRect(x1 + 3 * (GC / 8), y1 + (GC / 4), GC / 4, GC / 2);
            g.drawLine(x1 + (GC / 2), y1 + GC - (GC / 4), x1 + (GC / 2), y1 + GC);
            g.setFont(new Font("Arial", Font.PLAIN, GC / 5));
            setFillColor(g, selected);
            g.fillRect(x1 + GC / 8, y1 + (2 * GC / 5), (int)Math.round((NumOp.writeDouble(resistance).length()-0.2)*GC/9), GC / 4);
            g.setColor(COLOR_LINE);
            g.drawString(NumOp.writeDouble(resistance), x1 + GC / 8, y1 + (3 * GC / 5));
        }
    }

    @Override
    public boolean isCleared() {
        return false;
    }

    /**
     * @return the resistance
     */
    public double getResistance() {
        return resistance;
    }

    /**
     * @param resistance the resistance to set
     */
    public void setResistance(double resistance) {
        this.resistance = resistance;
    }

    /**
     * @return the horizontal
     */
    public boolean isHorizontal() {
        return horizontal;
    }

}
