package PresentationLayer.Grid;

import java.awt.Color;
import java.awt.Graphics;

/**
 * políčko mřížky
 * @author Jakub Hrncir (2010)
 */
public abstract class GridField {

    protected boolean dragSelected = false;
    protected boolean highlighted = false;
    protected Color COLOR_NOSELECT = Color.WHITE;
    protected Color COLOR_SELECT = Color.YELLOW;
    protected Color COLOR_DRAGSELECT = new Color(153, 255, 255);
    protected Color COLOR_LINE = Color.BLACK;
    protected Color COLOR_BORDER = Color.GRAY;
    protected Color COLOR_HIGHLIGHT = Color.GREEN;
    protected Color color_highlight = COLOR_HIGHLIGHT;
    protected int COLOR_CONST = 220;

    public abstract void paint(Graphics g, int x1, int y1, int GC, boolean selected, boolean paintMarks);

    public void setDragSelected(boolean selected) {
        dragSelected = selected;
    }

    public void setHighlighted(boolean highlighted) {
        this.highlighted = highlighted;
    }

    public abstract boolean isCleared();

    /**
     * nastaví barvu zvýraznění
     * @param green musí být mezi 0-1, 0 je nejsvětlejší, 1 nejtmavší zelená
     */
    public Color setHighlightColor(double green) {
        color_highlight = new Color((int) ((1 - green) * COLOR_CONST), 255, (int) ((1 - green) * COLOR_CONST));
        return new Color((int) ((1 - green) * COLOR_CONST), 255, (int) ((1 - green) * COLOR_CONST));
    }

    /**
     * nastaví barvu zvýraznění na standartní (nejtmavší)
     */
    public void setHighlightColor() {
        color_highlight = COLOR_HIGHLIGHT;
    }

    protected void setFillColor(Graphics g, boolean selected) {
        g.setColor((selected) ? COLOR_SELECT : COLOR_NOSELECT);
        if (dragSelected) {
            g.setColor(COLOR_DRAGSELECT);
        }
        if (highlighted) {
            g.setColor(color_highlight);
        }
    }
}
